/*
 *  ============================================================
 *  FoldedBox.java: Create instances of open folded box objects.
 *                  Compute and print the volume and surface
 *                  area of each box.
 *
 *  Written By: Mark Austin                             May 2007
 *  ============================================================
 */

package arraylist05;

public class FoldedBox {
   private String sName;
   private double dLength, dWidth, dHeight;

   // Custom constructor for creating folded box objects ....

   public FoldedBox ( String  sName, double dLength,
                      double dWidth, double dHeight ) {
      this.dLength = dLength;
      this.dWidth  = dWidth;
      this.dHeight = dHeight;
      this.sName   = sName;
   }

   // Compute box surface area and volume ....

   public double surfaceArea() {
     return dLength*dWidth + 2.0*(dLength+dWidth)*dHeight;
   }

   public double volume() {
     return dLength*dWidth*dHeight;
   }

   // Create String description of folded box characteristics ...

   public String toString() {
      String s = "FoldedBox: "  + sName + "\n";
      s = s + "Volume       = " + volume()   + "\n";
      s = s + "Surface Area = " + surfaceArea()   + "\n";
      return s;
   }

   // ===========================================================
   // Exercise methods in FoldedBox.java
   // ===========================================================

   public static void main ( String args [] ) {

      // Create and initialize folded box objects

      FoldedBox fbMatch = new FoldedBox ("Match",  2.0, 1.0, 0.5 );
      FoldedBox fbShoe  = new FoldedBox ( "Shoe", 12.0, 8.0, 7.0 );
      FoldedBox fbPacking  = new FoldedBox (  "Packing", 36.0, 36.0, 36.0 );
      FoldedBox fbGift     = new FoldedBox (     "Gift", 12.0, 12.0,  5.0 );
      FoldedBox fbDumpster = new FoldedBox ( "Dumpster", 72.0, 48.0, 48.0 );

      // Print details of each folded box ...

      System.out.println(    fbMatch.toString() );
      System.out.println(     fbShoe.toString() );
      System.out.println(  fbPacking.toString() );
      System.out.println(     fbGift.toString() );
      System.out.println( fbDumpster.toString() );
   }
}
