/*
 *  ======================================================================
 *  GeographicalRegion.java; Create simple model of a geographical region.
 *  ======================================================================
 */

package association05;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class GeographicalRegion {
   private String sName;

   // Setup collection of states ....

   private Collection<State> states;

   // Constructor method ....
    
   public GeographicalRegion(){
      states = new ArrayList<State>();
   }

   // Methods to deal with the region name ...
    
   public String getName() {
      return sName;
   }
    
   public void setName(String regionName ) {
      this.sName = regionName;
   }

   // Add a state to the geographical region ...

   public void addState( State st ) {

      if ( getStates().contains( st ) == false ) {
           getStates().add( st );
      }

      // Update departments on the student side ....

      if ( st.getGeographicalRegions().contains(this) == false ) {
           st.getGeographicalRegions().add(this);
      }
   }

   public Collection<State> getStates() {
      return states;
   }

   public void setState( Collection<State> states ) {
      this.states = states;
   }

   // Compute total population of the geographical region ...

   public int getPopulation() {
      int iPopulation = 0;

      Iterator iterator1 = states.iterator();
      while ( iterator1.hasNext() != false ) {
         State st = (State) iterator1.next();
         iPopulation = iPopulation + st.getPopulation();
      }

      return iPopulation;
   }

   // Create a String representation for the geographical region ...

   public String toString() {
      String s = "Geographical Region: " + sName + "\n";
      s = s + "States: ";
      if ( states.size() == 0 )
         s = s + " none \n";
      else {
         Iterator iterator1 = states.iterator();
         while ( iterator1.hasNext() != false ) {
            State st = (State) iterator1.next();
            s = s + st.getName() + " ";
         }
         s = s + "\n";
      }

      s = s + "Population: " + getPopulation() + "\n";

      return s;
   }
}
