/*
 *  =======================================================
 *  State.java; Create a "US state" object .....
 *  =======================================================
 */

package association05;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Iterator;

public class State {
   private String    sName;
   private int iPopulation;

   // Collection of regions to which the state belongs.

   private Collection<GeographicalRegion> regions;

   // Constuctor method ...

   public State( String sName ) {
      this.sName = sName;
      regions    = new ArrayList<GeographicalRegion>();
   }

   // Set and get methods for the State name ...

   public void setName( String sName ) {
      this.sName = sName;
   }

   public String getName() {
      return sName;
   }

   // Set and get methods for the State Population ...

   public void setPopulation( int iPopulation ) {
      this.iPopulation = iPopulation;
   }

   public int getPopulation() {
      return iPopulation;
   }

   // Add a State to a Region ....

   public void addGeographicalRegion( GeographicalRegion region ) {

     // Add new region to states membership ....

     if ( getGeographicalRegions().contains(region) == false ) {
          getGeographicalRegions().add(region);
     }

     // Update list of states belonging to region ....

     if ( region.getStates().contains(this) == false ) {
          region.getStates().add(this);
     }
   }

   // Return collection of regions ...

   public Collection<GeographicalRegion> getGeographicalRegions() {
      return regions;
   }

   // Create String representation of student object ...

   public String toString() {
      String s = "State: " + sName + "\n";
      s = s + "Population: " + iPopulation + "\n";

      s = s + "Regions: ";
      if ( regions.size() == 0 )
         s = s + " none \n";
      else {
         Iterator iterator1 = regions.iterator();
         while ( iterator1.hasNext() != false ) {
            GeographicalRegion r = (GeographicalRegion) iterator1.next();
            s = s + r.getName() + " ";
         }
         s = s + "\n";
      }

      return s;
   }
}
