/*
 *  =============================================================
 *  CountWordFrequency.java: Read a stream of words from a file.
 *  Use a hashmap to record the frequency of each word. Then use
 *  a treemap to order the words.
 *  =============================================================
 */

package hashmap02;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.*;

public class CountWordFrequency {

   public static void main(String args[]) throws IOException {

      Map map = new HashMap();
      Integer ONE = new Integer(1);

      // Create file reader for text input ...

      FileReader fin = new FileReader("data/textfile.txt");

      // Create scanner to read on file input stream ... 

      Scanner src = new Scanner(fin);

      // Read and process words from text file ...

      while (src.hasNext()) {
         String key = src.next();
         Integer frequency = (Integer) map.get( key );
         if (frequency == null) {
            frequency = ONE;
         } else {
            int value = frequency.intValue();
            frequency = new Integer(value + 1);
         }
         map.put(key, frequency);
      }

      // Print (unordered) contents of map ..

      System.out.println("HashMap of [ word, frequency ] usage");
      System.out.println("====================================");

      System.out.println(map);

      // Create and print an ordered treemap...

      System.out.println("TreeMap of [ word, frequency ] usage");
      System.out.println("====================================");

      Map sortedMap = new TreeMap(map);
      System.out.println(sortedMap);

      System.out.println("====================================");
   }
}
