/*
 * =============================================================================
 * AliasMap.java: 
 * =============================================================================
 */

package hashmap05;

import java.util.*;

// Test Program ....

public class TestAliasMap01 {
    public static void main ( String[] args ) {

       System.out.printf("Run TestAliasMap01 ... \n");
       System.out.printf("======================================================== \n");
       System.out.printf("PART 1: Aliases for Elvis Presley and Elvis Costello ... \n");
       System.out.printf("======================================================== \n");

       AliasMap<String, String> sm = new AliasMap<String, String>();

       System.out.printf("--- Data: sm.put(key,value) --> (Elvis, Presley) ... \n");

       sm.put( "Elvis", "Presley" );

       System.out.printf("--- Define: sm.alias(key,value) --> (Elvis, Prescilla ) ... \n");

       sm.alias( "Elvis", "Priscilla" );

       System.out.printf("--- Find: sm.get(\"Elvis\") --> (%s) ...\n", sm.get( "Elvis" ) );
       System.out.printf("--- Find: sm.get(\"Priscilla\") --> (%s) ... \n", sm.get( "Priscilla" ) );

       System.out.printf("--- \n");
       System.out.printf("--- Replace: sm.put(key,value) --> (Elvis, Costello) ... \n");

       sm.put( "Elvis", "Costello" );

       System.out.printf("--- Find: sm.get(\"Elvis\") --> (%s) ... \n", sm.get( "Priscilla" ) );
       System.out.printf("--- Find: sm.get(\"Prescilla\") --> (%s) ... \n", sm.get( "Priscilla" ) );

       System.out.printf("--- \n");
       System.out.printf("--- Print: keyset in alias map ... \n");
       System.out.printf("--- -------------------------- ... \n");

       for ( String s : sm.keySet() ) {
            System.out.printf("--- key = %s ...\n", s);
       }

       System.out.printf("--- \n");
       System.out.printf("--- Remove: Priscilla from alias map ... \n");

       for ( Iterator<Map.Entry<String, String>> iterator = sm.entrySet().iterator(); iterator.hasNext(); ) {
            Map.Entry<String, String> entry = iterator.next();
            if ( "Priscilla".equals( entry.getKey() ) ) {
                iterator.remove();
            }
       }

       System.out.printf("--- Print: Revised keyset in alias map ... \n");

       for ( String s : sm.keySet() ) {
            System.out.printf("--- key = %s ...\n", s);
       }

       System.out.printf("--- \n");
       System.out.printf("======================================================== \n");
       System.out.printf("PART 2: Aliases for States and State Capitals ... \n");
       System.out.printf("======================================================== \n");

       AliasMap<String, String> states = new AliasMap<String, String>();

       // Define states and their capitals ...

       System.out.printf("--- Define states and their capitals ...\n" );

       states.put(   "Maryland",  "Annapolis" );
       states.put(   "Virginia",   "Richmond" );
       states.put( "California", "Sacramento" );

       // Define postal code aliases for states ...

       System.out.printf("--- Define postal code aliases for each state ...\n" );

       states.alias(   "Maryland", "MD" );
       states.alias(   "Virginia", "VA" );
       states.alias( "California", "CA" );

       // Find and print state capitals for CA and MD ...

       System.out.printf("--- Find: State capital of CA --> %s ...\n", states.get( "CA" ) );
       System.out.printf("--- Find: State capital of MD --> %s ...\n", states.get( "MD" ) );

       System.out.printf("======================================================== \n");
       System.out.printf("Finished !! ... \n");
    }
}
