/* 
 *  ===========================================================================
 *  TestPassengerDataModel.java: Exercise passenger data model for the Titanic.
 * 
 *  Written by: Mark Austin                                          April 2022 
 *  ===========================================================================
 */ 

package homework03;

import java.io.IOException;

public class TestPassengerDataModel {
    public static void main (String [] args ) {
       System.out.printf("Enter TestPassengerDataModel.main() ... \n");
       System.out.printf("=================================== ... \n");

       // Create Weather data model ...

       PassengerDataModel titanic = new PassengerDataModel();
       titanic.setName("Titanic");

       // Load data/titanic.csv into model ...

       try {
          titanic.loadDataFile("data/titanic.csv");
       } catch (IOException e) {
          System.out.printf("Error: data file not found ...\n");
       }

       // Print summary of data ...

       System.out.println ( titanic.toString() );

       // Export data to Weka (arff) file format 

       try {
          titanic.exportARFF("./titanic-passenger-data.arff");
       } catch (Exception e) {
          System.out.printf("Error: Export to ARFF file format failed ...\n");
       }

       System.out.printf("================================= ... \n");
       System.out.printf("Finished! ... \n");
    }
}
