/*
 *  ===================================================================
 *  TestUniversity.java: Assemble university employees into a variety of
 *                       treeset organizations.
 *  ===================================================================
 */

package treeset01;

import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Set;
import java.util.TreeSet;

public class TestUniversity {
   public static void main(String args[]) {

      // Define employees at the University of Maryland ...

      Employee e01 = new Employee( "ISR/Finance", "Strahan, Jason");
      Employee e02 = new Employee( "ISR", "Sutton, Steve");
      Employee e03 = new Employee( "ISR", "Coriale, Jeff");
      Employee e04 = new Employee( "ISR", "Austin, Mark");
      Employee e05 = new Employee( "CEE", "Austin, Mark");
      Employee e06 = new Employee( "ISR", "Lovell, David");
      Employee e07 = new Employee( "CEE", "Lovell, David");
      Employee e08 = new Employee( "ISR", "Ghodssi, Reza");
      Employee e09 = new Employee( "ECE", "Ghodssi, Reza");
      Employee e10 = new Employee( "CEE", "Baecher, Greg");
      Employee e11 = new Employee( "CEE", "Haghani, Ali");
      Employee e12 = new Employee( "CEE", "Reilly, Allison");

      // Define arry of reference to employees ....

      Employee emps[] = { e01, e02, e03, e04, e05, e06,
                          e07, e08, e09, e10, e11, e12 };

      // Part 1. Assemble treeset from array of objects.

      System.out.println("Part 01: Create Treeset based on array of employees");
      System.out.println("===================================================");

      Set set01 = new TreeSet( Arrays.asList(emps) );
      System.out.println( set01 );

      // Part 2. Now use Collection.reverseOrder() method to reverse treeset
      //         assembly.

      System.out.println("\nPart 02: Reverse order assembly of items in TreeSet ");
      System.out.println("===================================================");

      Set set02 = new TreeSet( Collections.reverseOrder() );
      set02.addAll( Arrays.asList(emps) );
      System.out.println( set02 );

      // Part 3. Use EmployeeComparator to order items in treeset.

      System.out.println("\nPart 03: Use EmployeeComparator to Order TreeSet items");
      System.out.println("======================================================");

      Set set03 = new TreeSet( new EmployeeComparator() );
      for (int i = 0, n = emps.length; i < n; i++) {
         set03.add( emps[i] );
      }
      System.out.println( set03 );

    System.out.println("======================================================");
  }
}
